#!/usr/bin/python
#-*- coding:utf8 -*-

# Berechnung von Platinenheizungen

TODO = """TODO:
+ Ergebnisse auch in besser verständlichen Einheiten ausgeben (W/cm²).
- Formatieren: ausgegebene Dezimalstellen begrenzen.
- Fehler aufgrund der ganzzahligen Schlangenanzahl ausrechnen, inkl. elektrischer Werte.
- Für die zu erwartenden Fertigungsfehler (Leitungsbreiten- und -dickenschwankungen) eine geeignete Fehlerrechnung durchführen.
- Grenzwerte der Materialien mit ausgeben.
- Realisierbarkeit überprüfen (Grenzdaten der Materialien - dies erfordert jedoch die Kenntnis und Eingabe der Kühlung).
- Andere Parameter als Startvorgaben ermöglichen.
- Andere Formen ermöglichen (Kreis, Rechteck).
- Pins am Ende der Leiterbahnen.
- Pins immer nebeneinander legen. Rest geeignet anpassen.
- Korrekte Libraries erstellen (Symbol + Footprint, Bezeichnung mit elektrischen Daten und Grenzdaten).
- Berechnungsmethoden nochmal genau überprüfen.
- Testplatinen anfertigen und ausmessen."""


import math
debug = False

print '== Berechnung des Widerstands einer rechteckigen Leiterbahn gegebener Breite und Länge =='

Material = 'Cu'
print '- Material:', Material

Dicke_Kupferauflage = 0.000035 #35 µm
Dicke_Kupferauflage_SI = 'm'
print '- Dicke der Kupferauflage:', Dicke_Kupferauflage, Dicke_Kupferauflage_SI, '=', Dicke_Kupferauflage*1000000, 'µm'

Breite = raw_input('Breite in mm ? ')
Breite = float(Breite) / 1000 # in m umrechnen
Breite_SI = 'm'
print '- Breite:', Breite, Breite_SI

Laenge = raw_input('Länge in cm ? ')
Laenge = float(Laenge) / 100 # in m umrechnen
Laenge_SI = 'm'
print '- Länge:', Laenge, Laenge_SI

#Querschnitt A in [m²]
#Kreisrunder Leiter:
#A = math.pi * d^2 / 4

#Rechteckiger Querschnitt:
A = Dicke_Kupferauflage * Breite
A_SI = 'm²'
print '- Querschnitt der Leiterbahn:', A, A_SI, '=', A * 1000000, 'mm²'


#Spezifischer Widerstand ρ des Materials [Ω · mm2/m = Ωm]
#- Leiter: ρ < 10−6 Ωm
#- Halbleiter: ρ = 10−6…1010 Ωm
#- Isolatoren oder Nichtleiter: ρ > 1010 Ωm

# Kupfer: 16,78 ∙ 10−3  Ω · mm2/m, siehe http://de.wikipedia.org/wiki/Spezifischer_Widerstand
rho = 0.01678 / 1000 / 1000 #in m umrechnen
rho_SI = 'Ω · m²/m'
print '- Spezifischer Widerstand von Kupfer:', rho, rho_SI

#Widerstandsberechnung
R = rho * Laenge / A
R_SI = 'Ω'
print '- Widerstand der Leiterbahn:', R, R_SI

print
print '== Berechnung der Heizleistung dieser Leiterbahn bei gegebener Spannung =='

U = raw_input('Angelegte Spannung in V ? ')
U = float(U)
U_SI = 'V'
print '- Spannung:', U, U_SI

I = U / R
I_SI = 'A'
print '- Strom:', I, I_SI

P = U * I
P_SI = 'W'

print '- Heizleistung:', P, P_SI

print
print '== Erstellung eines KiCad-Symbols =='

print 'Ausgegangen wird hierbei von einer Leiterbahndichte von 1/2, d.h. die Leiterbahnen werden mit einem Abstand nebeneinander gelegt, der ihrer Breite entspricht.\nDie Anordnung erfolgt quadratisch in Schlangenlinien.'

Flaeche = Laenge * Breite * 2
Flaeche_SI = 'm²'
print '- Fläche:', Flaeche, Flaeche_SI, '=', Flaeche * 10000, 'cm²'

Kantenlaenge = math.sqrt(Flaeche)
Kantenlaenge_SI = 'm'
print '- Kantenlänge des Platinenheizungsquadrats:', Kantenlaenge, Kantenlaenge_SI, '=', Kantenlaenge*100, 'cm'

Leistung_pro_Flaeche = P / Flaeche
Leistung_pro_Flaeche_SI = 'W/m²'
print '- Leistung pro Platinenfläche:', Leistung_pro_Flaeche, Leistung_pro_Flaeche_SI, '=', Leistung_pro_Flaeche/10000, 'W/cm²'
print '- Leistung pro reiner Leiterbahnfläche:', Leistung_pro_Flaeche*2, Leistung_pro_Flaeche_SI, '=', Leistung_pro_Flaeche*2/10000, 'W/cm²'

Schlangen = int(Laenge / Kantenlaenge)
#Schlangen_SI = '(Anzahl)'
print '- Anzahl Leiterbahnschlangen (hin + rück):', Schlangen


#Aufbau der Leiterbahnen

# Format: Siehe hier: http://en.wikibooks.org/wiki/Kicad/file_formats
# Müsste eigentlich eine .emp-Datei werden, aber deren Format ist auf der Seite nicht beschrieben,
# daher ist mir das als Proof of Concept momentan mal egal.

filename = 'heater.lib'

print
print 'Erstelle KiCad Symbol-Datei:', filename

outfile = open(filename, 'w')

header = """EESchema-LIBRARY Version 2.2  Date: 01/06/2010-18:05:26
#
# Platinenheizung
#
DEF BOARDHEATER H 0 40 N N 1 0 N
F0 "H" 0 0 49 H V C C
F1 "BOARDHEATER" -100 400 49 V H C C
DRAW"""

footer = """ENDDRAW
ENDDEF
#
#End Library
"""


if debug: print header
outfile.write(header + '\n')
#Mathematische Koordinatenrichtungen

def m2mil(x):
	faktor = 100000.0/2.54
	return x * faktor

def leiterbahn( (x0, y0), (x1, y1) ):
	#print '(%.3f, %.3f), (%.3f, %.3f)' % (m2mil(x0), m2mil(y0), m2mil(x1), m2mil(y1))
	if debug: print 'P 2 0 1 %d %d %d %d %d N' % (m2mil(Breite), m2mil(x0), m2mil(y0), m2mil(x1), m2mil(y1))
	outfile.write('P 2 0 1 %d %d %d %d %d N\n' % (m2mil(Breite), m2mil(x0), m2mil(y0), m2mil(x1), m2mil(y1)))


anschluss = 0.007 #Länge des abgesetzten Anschlusses (in m) !

for i in range(Schlangen):
	#Schlangen
	if (i % 2) == 0: #hin und her
		#print i
		leiterbahn( (0,            i * 2 * Breite), (Kantenlaenge, i * 2 * Breite) ) #nach rechts
		leiterbahn( (Kantenlaenge, i * 2 * Breite), (Kantenlaenge, (i + 1) * 2 * Breite) ) #rechts hoch
	else:
		#print i
		leiterbahn( (Kantenlaenge, i * 2 * Breite), (0, i * 2 * Breite) ) #zurück nach links
		leiterbahn( (0,            i * 2 * Breite), (0, (i + 1) * 2 * Breite) ) #links hoch

#Anschlüsse
leiterbahn( (0,0), (-anschluss, 0)) #Anschluss links unten

if (Schlangen % 2) == 0: #Anschluss am Ende je nach Richtung der letzten Bahn.
	# Dies ist bei ungerader Schlangenzahl etwas unpraktisch. Man sollte lieber eine gerade Schlangenzahl erzwingen und ggf. die Breite etwas kürzen, aber dies ist ja mehr als Proof of Concept gedacht.
	#TODO: Auch die exakte Logik der Leitungspositionierung müsste man nochmal etwas überarbeiten...
	leiterbahn( (0, Kantenlaenge - (Breite * 2) ), (-anschluss, Kantenlaenge - (Breite * 2) ) ) #oben links
else:
	leiterbahn( (Kantenlaenge, Kantenlaenge-Breite), (Kantenlaenge + anschluss, Kantenlaenge-Breite) ) #unten rechts

if debug: print footer
outfile.write(footer)
print 'Datei geschrieben.'

print
print 'Nicht vergessen -',
print TODO

print
print 'Fertig.'
